/**
 * Copyright 2016 the WHATAP project authors. All rights reserved.
 * Use of this source code is governed by a license that
 * can be found in the LICENSE file.
 */

var TraceContextManager = require('../trace/trace-context-manager'),
    Logger = require('../logger');

var GlobalObserver = function (agent) {
    this.agent = agent;
    this.packages = ['global'];
}

GlobalObserver.prototype.inject = function (mod, moduleName) {
    var self = this;

    ['setTimeout', 'setInterval', 'setImmediate'].forEach(function (funcName) {
        self.agent.aop.before(mod, funcName, function (obj, args) {
            if(args[args.length - 1] === 'whatap') { return; }

            var cached_id = TraceContextManager.getCurrentId();
            self.agent.aop.functionHook(args, 0, function (obj, args) {
                TraceContextManager.resume(cached_id);
                cached_id = null;
            });
        });
    });
};

exports.GlobalObserver = GlobalObserver;